.org 0
zero:
jmp start
chaine:
.ascii "BABO Loading ....."
.byte 13,10,0
readsector:
.byte 0x66,0x0,0x0,0x0,0x02,0x2,10,27,0xff,0xfe
dat:
.byte 0,0,0,0,0,0,0
.byte 0,0,0
point:
.byte 46,0
adresse:
.word 0,0

start:
    
    mov ax, #0x07c0
    mov ds, ax
    mov es, ax
    mov ax, #chaine
    call print
    
    
    jmp suite

suite:


    mov al, #0x1c
    mov dx, #0x3f2
    out dx,al
   
    call mrqloop
    
    mov bx, #0
    mov ax,#0x0800
    mov es,ax
    call dma
    
    mov dx, #0x3f5
    mov ax,#readsector
    call data

    mov ax, #dat
    call readdata

;    mov [adresse+2],es
;    mov ax,#0x0800
;    mov cs,ax
;    jmp zero
;   mov ax, #512
;   call print
   
    
    call busyloop
   
    mov al,#0
    mov dx,#0x3f2
    out dx,al
    
   
    jmpi zero,0x0800

   
;    mov ax,#0x0800
;    mov ds,ax
;    mov ax,#chaine

;    call print

ennd:
jmp ennd

affoctet:
    push ax
    push bx
    
    push bx
    mov ah,#0x0e
    shr bh,#4
    and bh,#0x0f
    
    cmp bh,#0x0a
    jb petitadd

    
    add bh,#0x37
petitret:
    mov al, bh
    mov bl, #0
    int #0x10
    pop bx
    and bh,#0x0f
    cmp bh,#0x0a
    jb petitadd2
    add bh,#0x37
petitret2: 
    mov al, bh
    mov bl, #0
    int #0x10
    
    pop bx
    pop ax
    ret
		
petitadd:
    add bh,#0x30
    jmp petitret
petitadd2:
    add bh,#0x30
    jmp petitret2


print:
    push ax
    push si
    push bx
    mov si, ax
bcl:
    cmpb [si],#0
    je fin
    mov ah,#0x0e
    mov al, [si]
    mov bl, #0
    int #0x10
    inc si
    jmp bcl

fin:

    pop bx
    pop si
    pop ax
    ret


readdata:
    mov si,ax
    mov cx,#7

bcl3:
    cmp cx,#0
    je fin3
    call mrqloop2
    in al,dx
    mov [si],al
    inc si
    dec cx
    jmp bcl3

fin3:

    ret


data:
    
    mov si, ax
bcl2:
    cmpb [si],#0xfe
    je fin2
    movb al,[si]
    call mrqloop
    out dx,al
    inc si
    jmp bcl2

fin2:

    ret


mrqloop2:
    push ax
    push bx
    push dx
mrqlop2:    
    mov dx,#0x3f4
    in al,dx
    and al,#0xc0
    cmp al,#0xc0
    jne mrqlop2
    pop dx
    pop bx
    pop ax
    ret		    

busyloop:

    push ax
    push dx
busylop:
    
    mov dx,#0x3f4
    in al,dx
;    push bx
;    mov bh,al
;    call affoctet
;    pop bx
    and al,#0x10
    cmp al,#0x10
    je busylop
    
    pop dx
    pop ax
    
    ret		    


mrqloop:

    push ax
    push dx
mrqlop:
    
    mov dx,#0x3f4
    in al,dx
    and al,#0xc0
    cmp al,#0x80
    jne mrqlop
    
    pop dx
    pop ax
    
    ret		    

dma:

disable_dma1:          ; disable DMA 1

mov     al, #0x14    ; output 14h to the command register to disable and
out     #0x08, al    ; initialise the DMA controller

mode:                  ; set up DMA transfer mode for channel 2
mov     al, #0x56    ; set  up for a single write transfer to main memory
out     #0x0b, al    ; using DMA channel 2
; for a read, output 5ah

get_address:           ; get the buffer address, and split into component parts
; as required by the DMA controller.
mov     ax, es     ; load buffer segment into AX
mov     cl, #0x04    ;
shl     ax, cl     ; shift value in ax left 4 times
add     ax, bx     ; add offest + buffer. AX now contains high and low 
; for the DMA address register.
jc      carry      ; if carry is set, jump to carry

no_carry:
mov     bx, es     ; load segment of buffer into BX
mov     cl, #0x04    ;
shr     bh, cl     ; shift right BH 4 times. BH now contains the value
; for the DMA page segment
jmp  buffer_address; output the buffer address

carry:
mov     bx, es     ; load segment of buffer into BX
mov     cl, #0x04    ;
shr     bh, cl     ; shift right BH 4 times.  BH now contains the high
; bits of the segment
adc     bh, #0x00

buffer_address:        ; output the address to the DMA controller
out     #0x0c, al    ; reset flip-flop. I am not sure what this does,
; but my reference shows this as necessary.
out     #0x04, al    ; output low order address byte to address register
mov     al, ah     ;
out     #0x04, al    ; output high-order address byte to address register
mov     al, bh     ;
out     #0x81, al    ; load page register with page value

count:                 ; set up count register
out     #0x0c, al    ; reset flip-flop
mov     al, #0xff   ;
out     #0x05, al    ;
mov     al, #19    ;
out     #0x05, al    ; load 511 into count register (to read one sector)
; it should be noted that for multiple transfers, the
; second value output to port 05h is equivalent to
; (2*number of sectors)-1
release_channel:
mov     al, #0x02
out     #0x0a, al    ; release channel 2

enable_dma1:           ; enable DMA 1
mov     al, #0x10
out     #0x08, al   ; this is the value for enabling the DMA for the mode required

ret
